/*## (c) SECURITY EXPLORATIONS    2018 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.util.*;
import java.io.*;
import jregex.*;

public class Invoice {
 public static class Service {
  String name;
  String s2;
  String price;
  String s4;

  public Service(String name,String s2,String price,String s4) {
   this.name=name;
   this.s2=s2;
   this.price=price;
   this.s4=s4;
  }

  public Service(String s1,String s2,String s3) {
   this(s1,s2,s3,null);
  }
 }

 public static class ServicePackage {
  String name;
  Vector services;

  public ServicePackage(String name,Vector services) {
   this.name=name;
   this.services=services;
  }
 }

 public static final int PAD  = 56;
 public static final int PAD2 = 18;
 public static final int PAD3 = 12;

 public static final int AGREEMENT_NUMBER   = 0;
 public static final int INVOICE_NUMBER     = 1;
 public static final int START_DATE         = 2;
 public static final int END_DATE           = 3;
 public static final int ISSUE_DATE         = 4;
 public static final int PREVIOUS_BALANCE   = 5;
 public static final int CLIENTS_PAYMENTS   = 6;
 public static final int CORRECTIONS        = 7;
 public static final int REMAINING_BALANCE  = 8;
 public static final int SETTLEMENT         = 9;
 public static final int PAYMENT_AMOUNT     = 10;
 public static final int ACCOUNT_NUMBER     = 11;
 public static final int PAYMENT_DEADLINE   = 12;
 public static final int MAGIC_STRING       = 13;
 public static final int PREV_MAGIC_STRING  = 14;
 public static final int INFO_HASHARRAY_IDX = 15;

 public static final int CLIENT_NUMBER      = 16;
 public static final int PAYMENT_METHOD     = 17;
 public static final int INVOICE_ISSUER     = 18;

 private static String services_hash_05d88005[]={
   "Filmbox",
   "Cinemax",
   "Filmbox",
   "Cinemax",
   "HBO + nFilmHD",
   "nPremium + HBO",
   "History HD",
   "History HD",
   "Kanaly tematyczne nc+",
   "NOC",
   "RedLight HD",
   "RedLight HD",
   "NOC",
   "Multi+",
   "SunDance HD",
   "SunDance HD",
   "Multi+",
   "Universe+",
   "Kanaly CANAL+ Film&Premiere",
   "Kanaly CANAL+ Premiere",
   "CANAL+ Gold + HBO",
   "All Inclusive+",
   "Premium Film",
   "Comfort+",
   "Extra+",
   "CANAL+ Silver",
   "Extra+",
   "CANAL+ Gold",
   "CANAL+ Platinum",
   "CANAL+ Platinum + HBO",
   "Czynsz najmu sprzetu",
   "HBO",
   "Premium Sport & Film",
   "VOD+",
   "Premium Family & Sport",
   "CANAL+ PLATINUM (opcja)",
   "HBO",
   "Inne oplaty",
   "Premium Sport & Film",
   "Premium Sport",
   "Premium Film",
   "Premium Sport",
   "Mezzo",
   "Mezzo",
   "Inne oplaty",
   "VOD+",
   "nc+ GO",
   "Premium Family & Sport",
   "TV France",
   "Comfort+ Extra",
   "PAPIEROWA FORMA ROZLICZENIA",
   "Universe+ Extra",
   "nc+ GO",
   "HBO GO",
   "Kanaly CANAL+ Film&Premiere",
   "Kanaly CANAL+ Premiere",
   "TV France",
   "Pozostale uslugi",
   "CANAL+ SILVER (opcja)",
   "Sportklub",
   "Full extra",
   "Motowizja",
   "Adventure TV HD",
   "CANAL+ Film&Premiere pack",
   "Adventure TV HD",
   "Hustler HD",
   "Hustler HD",
   "Start+ Extra",
   "CANAL+ Film pack",
   "Start+ Mini",
   "Eurosport 2 HD",
   "Zest TV",
   "Motowizja",
   "Eurosport 2 HD",
   "Konto podstawowe",
   "nc+go TV",
   "History HD / H2",
   "H2",
   "nc+go TV",
   "H2",
   "Zest/Motowizja/Sportklub",
   "History HD / H2",
   "Premiery VOD+",
   "Pakiet Informacja i Rozrywka",
   "Pakiet Dzieci",
   "Pakiet Hity Filmowe",
   "Pakiet Kultura Nauka swiat",
   "Pakiet Sport i Motoryzacja",
   "Pakiet Style Moda i Muzyka",
   "HBO + nFilmHD",
   "Pakiet Dzieci",
   "Nowy Start HD",
   "Max Pack",
   "Pakiet Hity Filmowe",
   "Max Pack",
   "nPremium + nSeriale",
   "Mix VOD",
   "Pakiet Kultura Nauka swiat",
   "Pakiet Start HD",
   "nPremium + HBO + nSeriale",
   "nPremium + HBO + nSeriale",
   "nPremium + HBO",
   "Pakiet Sport i Motoryzacja",
   "Mix VOD",
   "HBO + nFilmHD + nSeriale",
   "nPremium + nSeriale",
   "Kanaly tematyczne nc+",
   "HBO + nFilmHD + nSeriale",
   "Pakiet VIP+",
   "Man Pack",
   "Pakiet Comfort+",
   "Pakiet Extra+ z CANAL+",
   "Pakiet Extra+",
   "Pakiet Superpremium+",
   "Dopelnienie do Extra+",
   "Man Pack",
   "Dopelnienie do Extra+",
   "Pakiet Extra+ z CANAL+ (6)",
   "Sportklub",
   "Pakiet Comfort+ z CANAL+",
   "Pakiet Extra+ z HBO",
   "Pakiet Comfort+ z CANAL+ (6)",
   "Pakiet Start+ z CANAL+ (6)",
   "Pakiet Start+",
   "Pakiet VIP+ Max",
   "Pakiet Superpremium+ (6)",
   "CANAL+",
   "Action",
   "Pakiet Entry+",
   "Pakiet Entry+ z CANAL+",
   "Zest/Motowizja/Sportklub",
   "Dopelnienie do Comfort+",
   "Dopelnienie do Comfort+",
   "Pakiet Start+ z CANAL+",
   "Pakiet Comfort+ z HBO",
   "Pakiet Start+ z HBO",
   "Pakiet Entry+ z CANAL+ (6)",
   "Action",
   "Zest TV",
   "Pakiet Comfort+ Bonus",
   "CANAL+ (6)",
   "Pakiet Entry+ z HBO",
   "Eleven Sports",
   "Eleven Sports",
   "Pakiet Comfort+ Bis",
   "Pakiet Extra+ Bonus",
   "Filmbox Pack",
   "Filmbox Pack",
   "Filmbox Arthouse",
   "Filmbox Arthouse",
   "Fightbox HD",
   "Fightbox HD",
   "Pakiet Superpremium(6)LIVE",
   "Pakiet Extra+CANAL+(6)LIVE",
   "Pakiet ComfortCANAL+(6)LIVE",
   "Pakiet Start+CANAL+(6)LIVE",
   "Oplata za nc+ GO",
   "CANAL+ (2) LIVE",
   "CANAL+ (2)",
   "Oplata za nc+ GO",
   "Dopelnienie do Start+",
   "Multi Man Pack",
   "Czynsz najmu sprzetu",
   "Hustler HD 2",
   "Hustler HD 2",
   "Multiroom Premium-Opl.mani.",
   "Multiroom Standard-Opl.mani.",
   "Multiroom Standard-Opl.mani.",
   "Oplata manipulacyjna MRS",
   "Oplata manipulacyjna MRS",
   "Multiroom Premium-Opl.mani.",
   "Zest TV 2",
   "Dorcel TV",
   "Dorcel TV",
   "Zest TV 2",
   "Music+ Standard",
   "Music+ Premium",
   "Music+ Premium",
   "Music+ Standard",
   "Pakiet Entry+ Gotowka z Gory",
   "Odsetki za okres 03/06/2018 - 02/07/2018",
   "Odsetki za okres 03/06/2018 - 02/07/2018",
   "Odsetki za okres 03/05/2018 - 02/07/2018",
   "Odsetki za okres 03/05/2018 - 02/07/2018",
   "Odsetki za okres 03/03/2018 - 02/07/2018",
   "Odsetki za okres 03/02/2018 - 02/07/2018",
   "Odsetki za okres 03/04/2018 - 02/07/2018",
   "Odsetki za okres 03/01/2018 - 02/07/2018",
   "Multi Man Pack",
   "Odsetki za okres 03/07/2018 - 02/08/2018",
   "Odsetki za okres 03/07/2018 - 02/08/2018",
   "MISTRZOWSKA PILKA",
   "MISTRZOWSKA PILKA",
   "Odsetki za okres 03/06/2018 - 02/08/2018",
   "CANAL+ (6)",
   "Odsetki za okres 03/05/2018 - 02/08/2018",
   "Odsetki za okres 03/05/2018 - 02/08/2018",
   "Odsetki za okres 03/04/2018 - 02/08/2018",
   "Dopelnienie do Start+",
   "Odsetki za okres 03/05/2017 - 02/08/2018",
   "Odsetki za okres 03/08/2018 - 02/09/2018",
   "Odsetki za okres 03/08/2018 - 02/09/2018",
   "Odsetki za okres 03/07/2018 - 02/09/2018",
   "Odsetki za okres 03/07/2018 - 02/09/2018",
   "CANAL+4K ULTRA HD",
   "CANAL+4K ULTRA HD",
   "Odsetki za okres 03/05/2018 - 02/09/2018",
   "Odsetki za okres 03/06/2018 - 02/09/2018",
   "Odsetki za okres 03/06/2018 - 02/09/2018",
   "Odsetki za okres 03/05/2018 - 02/09/2018",
   "Odsetki za okres 03/09/2018 - 02/10/2018",
   "Odsetki za okres 03/09/2018 - 02/10/2018",
   "Odsetki za okres 03/08/2018 - 02/10/2018",
   "Odsetki za okres 03/05/2018 - 02/10/2018",
   "Odsetki za okres 03/08/2018 - 02/10/2018",
   "Odsetki za okres 03/07/2018 - 02/10/2018",
   "Odsetki za okres 03/06/2018 - 02/10/2018",
   "Odsetki za okres 03/07/2018 - 02/10/2018",
   "Odsetki za okres 03/06/2018 - 02/10/2018",
   "Odsetki za okres 03/03/2018 - 02/10/2018",
   "Odsetki za okres 03/05/2018 - 02/10/2018",
   "Odsetki za okres 03/03/2018 - 02/10/2018",
   "Pakiet Extra+ z CANAL+ Bonus",
   "Odsetki za okres 03/11/2017 - 02/10/2018",
   "nFilmHD + nSeriale",
   "Odsetki za okres 03/04/2018 - 02/10/2018",
   "Odsetki za okres 03/02/2018 - 02/10/2018",
   "Odsetki za okres 03/04/2018 - 02/10/2018",
   "Odsetki za okres 03/07/2017 - 02/10/2018",
   "Odsetki za okres 03/08/2017 - 02/10/2018",
   "Pakiet VIP+",
   "Zestaw START HD",
   "HBO HD",
   "Odsetki za okres 03/02/2018 - 02/10/2018"
 };

 private static String service_packages_hash_05d88005[]={
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Pakiety",
  "",
  "",
  "Pakiety",
  "Pakiety",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Inne",
  "Opcje premium",
  "",
  "",
  "",
  "Opcje premium",
  "",
  "",
  "Opcje premium",
  "Opcje premium",
  "Opcje premium",
  "",
  "Opcje dodatkowe",
  "",
  "Inne",
  "Opcje VOD",
  "",
  "Opcje premium",
  "",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pozostale uslugi",
  "Opcje premium",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje premium",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje VOD",
  "",
  "",
  "",
  "Opcje VOD",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Oferta VOD",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje VOD",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "",
  "",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Inne",
  "",
  "Inne",
  "Inne",
  "Inne",
  "Inne",
  "Inne",
  "",
  "",
  "Inne",
  "",
  "Opcje dodatkowe",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "Opcje dodatkowe",
  "Inne",
  "Inne",
  "",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "Inne",
  "Inne",
  "",
  "",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "",
  "",
  "Inne",
  "Inne",
  "Inne",
  "",
  "",
  "Pakiety",
  "Inne",
  "Opcje dodatkowe",
  "Inne",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "Pakiety",
  "Opcje premium",
  ""
 };

 private static String services_hash_05e1959b[]={
  "Filmbox",
  "Cinemax",
  "Filmbox",
  "Cinemax",
  "HBO + nFilmHD",
  "nPremium + HBO",
  "History HD",
  "History HD",
  "Kanay tematyczne nc+",
  "NOC",
  "RedLight HD",
  "RedLight HD",
  "NOC",
  "Multi+",
  "SunDance HD",
  "SunDance HD",
  "Multi+",
  "Universe+",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "CANAL+ Gold + HBO",
  "All Inclusive+",
  "Premium Film",
  "Comfort+",
  "Extra+",
  "CANAL+ Silver",
  "Extra+",
  "CANAL+ Gold",
  "CANAL+ Platinum",
  "CANAL+ Platinum + HBO",
  "Czynsz najmu sprztu",
  "HBO",
  "Premium Sport & Film",
  "VOD+",
  "Premium Family & Sport",
  "CANAL+ PLATINUM (opcja)",
  "HBO",
  "Inne opaty",
  "Premium Sport & Film",
  "Premium Sport",
  "Premium Film",
  "Premium Sport",
  "Mezzo",
  "Mezzo",
  "Inne opaty",
  "VOD+",
  "nc+ GO",
  "Premium Family & Sport",
  "TV France",
  "Comfort+ Extra",
  "PAPIEROWA FORMA ROZLICZENIA",
  "Universe+ Extra",
  "nc+ GO",
  "HBO GO",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "TV France",
  "Pozostae usugi",
  "CANAL+ SILVER (opcja)",
  "Sportklub",
  "Full extra",
  "Motowizja",
  "Adventure TV HD",
  "CANAL+ Film&Premiere pack",
  "Adventure TV HD",
  "Hustler HD",
  "Hustler HD",
  "Start+ Extra",
  "CANAL+ Film pack",
  "Start+ Mini",
  "Eurosport 2 HD",
  "Zest TV",
  "Motowizja",
  "Eurosport 2 HD",
  "Konto podstawowe",
  "nc+go TV",
  "History HD / H2",
  "H2",
  "nc+go TV",
  "H2",
  "Zest/Motowizja/Sportklub",
  "History HD / H2",
  "Premiery VOD+",
  "Pakiet Informacja i Rozrywka",
  "Pakiet Dzieci",
  "Pakiet Hity Filmowe",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Sport i Motoryzacja",
  "Pakiet Style Moda i Muzyka",
  "HBO + nFilmHD",
  "Pakiet Dzieci",
  "Nowy Start HD",
  "Max Pack",
  "Pakiet Hity Filmowe",
  "Max Pack",
  "nPremium + nSeriale",
  "Mix VOD",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Start HD",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO",
  "Pakiet Sport i Motoryzacja",
  "Mix VOD",
  "HBO + nFilmHD + nSeriale",
  "nPremium + nSeriale",
  "Kanay tematyczne nc+",
  "HBO + nFilmHD + nSeriale",
  "Pakiet VIP+",
  "Man Pack",
  "Pakiet Comfort+",
  "Pakiet Extra+ z CANAL+",
  "Pakiet Extra+",
  "Pakiet Superpremium+",
  "Dopenienie do Extra+",
  "Man Pack",
  "Dopenienie do Extra+",
  "Pakiet Extra+ z CANAL+ (6)",
  "Sportklub",
  "Pakiet Comfort+ z CANAL+",
  "Pakiet Extra+ z HBO",
  "Pakiet Comfort+ z CANAL+ (6)",
  "Pakiet Start+ z CANAL+ (6)",
  "Pakiet Start+",
  "Pakiet VIP+ Max",
  "Pakiet Superpremium+ (6)",
  "CANAL+",
  "Action",
  "Pakiet Entry+",
  "Pakiet Entry+ z CANAL+",
  "Zest/Motowizja/Sportklub",
  "Dopenienie do Comfort+",
  "Dopenienie do Comfort+",
  "Pakiet Start+ z CANAL+",
  "Pakiet Comfort+ z HBO",
  "Pakiet Start+ z HBO",
  "Pakiet Entry+ z CANAL+ (6)",
  "Action",
  "Zest TV",
  "Pakiet Comfort+ Bonus",
  "CANAL+ (6)",
  "Pakiet Entry+ z HBO",
  "Eleven Sports",
  "Eleven Sports",
  "Pakiet Comfort+ Bis",
  "Pakiet Extra+ Bonus",
  "Filmbox Pack",
  "Filmbox Pack",
  "Filmbox Arthouse",
  "Filmbox Arthouse",
  "Fightbox HD",
  "Fightbox HD",
  "Pakiet Superpremium(6)LIVE",
  "Pakiet Extra+CANAL+(6)LIVE",
  "Pakiet ComfortCANAL+(6)LIVE",
  "Pakiet Start+CANAL+(6)LIVE",
  "Opata za nc+ GO",
  "CANAL+ (2) LIVE",
  "CANAL+ (2)",
  "Opata za nc+ GO",
  "Multi Man Pack",
  "Czynsz najmu sprztu",
  "Hustler HD 2",
  "Hustler HD 2",
  "Multiroom Premium-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Opata manipulacyjna MRS",
  "Opata manipulacyjna MRS",
  "Multiroom Premium-Op.mani.",
  "Zest TV 2",
  "Dorcel TV",
  "Dorcel TV",
  "Zest TV 2",
  "Music+ Standard",
  "Music+ Premium",
  "Music+ Premium",
  "Music+ Standard",
  "Pakiet Entry+ Gotwka z Gry",
  "Odsetki za okres 03/07/2018 - 02/08/2018",
  "Odsetki za okres 03/07/2018 - 02/08/2018",
  "MISTRZOWSKA PI??KA",
  "MISTRZOWSKA PI??KA",
  "Odsetki za okres 03/06/2018 - 02/08/2018",
  "CANAL+ (6)",
  "Odsetki za okres 03/05/2018 - 02/08/2018",
  "Odsetki za okres 03/05/2018 - 02/08/2018",
  "Odsetki za okres 03/04/2018 - 02/08/2018",
  "Odsetki za okres 03/05/2017 - 02/08/2018",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/07/2018 - 02/09/2018",
  "CANAL+4K ULTRA HD",
  "CANAL+4K ULTRA HD",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/09/2018 - 02/10/2018",
  "Odsetki za okres 03/09/2018 - 02/10/2018",
  "Odsetki za okres 03/08/2018 - 02/10/2018",
  "Odsetki za okres 03/08/2018 - 02/10/2018",
  "Odsetki za okres 03/07/2018 - 02/10/2018",
  "Odsetki za okres 03/07/2018 - 02/10/2018",
  "Odsetki za okres 03/06/2018 - 02/10/2018",
  "Odsetki za okres 03/11/2017 - 02/10/2018",
  "nFilmHD + nSeriale",
  "Odsetki za okres 03/10/2018 - 02/11/2018",
  "Odsetki za okres 03/10/2018 - 02/11/2018",
  "Odsetki za okres 03/09/2018 - 02/11/2018",
  "Nowy Comfort+",
  "Odsetki za okres 03/08/2018 - 02/11/2018",
  "Nowy Comfort+ z CANAL+ (6)LIVE",
  "Nowy Comfort+ z CANAL+",
  "Odsetki za okres 03/09/2018 - 02/11/2018",
  "Nowy Comfort+ z HBO",
  "Nowy Start+",
  "Dopenienie do Nowy Comfort+",
  "Dopenienie do Nowy Start+",
  "Dopenienie do Nowy Comfort+",
  "Odsetki za okres 03/08/2018 - 02/11/2018",
  "Odsetki za okres 03/05/2018 - 02/11/2018",
  "Nowy Start+ z CANAL+",
  "CANAL+ (2) LIVE",
  "Nowy Start+ z HBO",
  "Odsetki za okres 03/07/2018 - 02/11/2018",
  "Odsetki za okres 03/03/2018 - 02/11/2018",
  "Odsetki za okres 03/05/2018 - 02/11/2018",
  "Odsetki za okres 03/03/2018 - 02/11/2018",
  "Odsetki za okres 03/04/2018 - 02/11/2018",
  "Naprawa Instalacji Sat.",
  "Odsetki za okres 03/07/2018 - 02/11/2018",
  "Nowy Start+ z CANAL+ (6) LIVE",
  "Odsetki za okres 03/02/2018 - 02/11/2018",
  "Odsetki za okres 03/06/2018 - 02/11/2018",
  "Odsetki za okres 03/06/2018 - 02/11/2018",
  "Odsetki za okres 03/01/2018 - 02/11/2018"
 };

 private static String service_packages_hash_05e1959b[]={
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Pakiety",
  "",
  "",
  "Pakiety",
  "Pakiety",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Inne",
  "Opcje premium",
  "",
  "",
  "",
  "Opcje premium",
  "",
  "",
  "Opcje premium",
  "Opcje premium",
  "Opcje premium",
  "",
  "Opcje dodatkowe",
  "",
  "Inne",
  "Opcje VOD",
  "",
  "Opcje premium",
  "",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pozostae usugi",
  "Opcje premium",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje premium",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje VOD",
  "",
  "",
  "",
  "Opcje VOD",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Oferta VOD",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje VOD",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Inne",
  "",
  "Opcje dodatkowe",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "Inne",
  "Inne",
  "",
  "Inne",
  "",
  "Opcje dodatkowe",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "",
  "",
  "Inne",
  "Inne",
  "Inne",
  "Opcje dodatkowe",
  "Inne",
  "",
  "",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Pakiety",
  "",
  "Pakiety",
  "Inne",
  "Inne",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "Pakiety",
  "Inne",
  "Inne",
  "",
  ""
 };

 private static String services_hash_05e19c4b[]={
  "Filmbox",
  "Cinemax",
  "Filmbox",
  "Cinemax",
  "HBO + nFilmHD",
  "nPremium + HBO",
  "History HD",
  "History HD",
  "Kanay tematyczne nc+",
  "NOC",
  "RedLight HD",
  "RedLight HD",
  "NOC",
  "Multi+",
  "SunDance HD",
  "SunDance HD",
  "Multi+",
  "Universe+",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "CANAL+ Gold + HBO",
  "All Inclusive+",
  "Premium Film",
  "Comfort+",
  "Extra+",
  "CANAL+ Silver",
  "Extra+",
  "CANAL+ Gold",
  "CANAL+ Platinum",
  "CANAL+ Platinum + HBO",
  "Czynsz najmu sprztu",
  "HBO",
  "Premium Sport & Film",
  "VOD+",
  "Premium Family & Sport",
  "CANAL+ PLATINUM (opcja)",
  "HBO",
  "Inne opaty",
  "Premium Sport & Film",
  "Premium Sport",
  "Premium Film",
  "Premium Sport",
  "Mezzo",
  "Mezzo",
  "Inne opaty",
  "VOD+",
  "nc+ GO",
  "Premium Family & Sport",
  "TV France",
  "Comfort+ Extra",
  "PAPIEROWA FORMA ROZLICZENIA",
  "Universe+ Extra",
  "nc+ GO",
  "HBO GO",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "TV France",
  "Pozostae usugi",
  "CANAL+ SILVER (opcja)",
  "Sportklub",
  "Full extra",
  "Motowizja",
  "Adventure TV HD",
  "CANAL+ Film&Premiere pack",
  "Adventure TV HD",
  "Hustler HD",
  "Hustler HD",
  "Start+ Extra",
  "CANAL+ Film pack",
  "Start+ Mini",
  "Eurosport 2 HD",
  "Zest TV",
  "Motowizja",
  "Eurosport 2 HD",
  "Konto podstawowe",
  "nc+go TV",
  "History HD / H2",
  "H2",
  "nc+go TV",
  "H2",
  "Zest/Motowizja/Sportklub",
  "History HD / H2",
  "Premiery VOD+",
  "Pakiet Informacja i Rozrywka",
  "Pakiet Dzieci",
  "Pakiet Hity Filmowe",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Sport i Motoryzacja",
  "Pakiet Style Moda i Muzyka",
  "HBO + nFilmHD",
  "Pakiet Dzieci",
  "Nowy Start HD",
  "Max Pack",
  "Pakiet Hity Filmowe",
  "Max Pack",
  "nPremium + nSeriale",
  "Mix VOD",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Start HD",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO",
  "Pakiet Sport i Motoryzacja",
  "Mix VOD",
  "HBO + nFilmHD + nSeriale",
  "nPremium + nSeriale",
  "Kanay tematyczne nc+",
  "HBO + nFilmHD + nSeriale",
  "Pakiet VIP+",
  "Man Pack",
  "Pakiet Comfort+",
  "Pakiet Extra+ z CANAL+",
  "Pakiet Extra+",
  "Pakiet Superpremium+",
  "Dopenienie do Extra+",
  "Man Pack",
  "Dopenienie do Extra+",
  "Pakiet Extra+ z CANAL+ (6)",
  "Sportklub",
  "Pakiet Comfort+ z CANAL+",
  "Pakiet Extra+ z HBO",
  "Pakiet Comfort+ z CANAL+ (6)",
  "Pakiet Start+ z CANAL+ (6)",
  "Pakiet Start+",
  "Pakiet VIP+ Max",
  "Pakiet Superpremium+ (6)",
  "CANAL+",
  "Action",
  "Pakiet Entry+",
  "Pakiet Entry+ z CANAL+",
  "Zest/Motowizja/Sportklub",
  "Dopenienie do Comfort+",
  "Dopenienie do Comfort+",
  "Pakiet Start+ z CANAL+",
  "Pakiet Comfort+ z HBO",
  "Pakiet Start+ z HBO",
  "Pakiet Entry+ z CANAL+ (6)",
  "Action",
  "Zest TV",
  "Pakiet Comfort+ Bonus",
  "CANAL+ (6)",
  "Pakiet Entry+ z HBO",
  "Eleven Sports",
  "Eleven Sports",
  "Pakiet Comfort+ Bis",
  "Pakiet Extra+ Bonus",
  "Filmbox Pack",
  "Filmbox Pack",
  "Filmbox Arthouse",
  "Filmbox Arthouse",
  "Fightbox HD",
  "Fightbox HD",
  "Pakiet Superpremium(6)LIVE",
  "Pakiet Extra+CANAL+(6)LIVE",
  "Pakiet ComfortCANAL+(6)LIVE",
  "Pakiet Start+CANAL+(6)LIVE",
  "Opata za nc+ GO",
  "CANAL+ (2) LIVE",
  "CANAL+ (2)",
  "Opata za nc+ GO",
  "Multi Man Pack",
  "Czynsz najmu sprztu",
  "Hustler HD 2",
  "Hustler HD 2",
  "Multiroom Premium-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Opata manipulacyjna MRS",
  "Opata manipulacyjna MRS",
  "Multiroom Premium-Op.mani.",
  "Zest TV 2",
  "Dorcel TV",
  "Dorcel TV",
  "Zest TV 2",
  "Music+ Standard",
  "Music+ Premium",
  "Music+ Premium",
  "Music+ Standard",
  "Pakiet Entry+ Gotwka z Gry",
  "MISTRZOWSKA PI??KA",
  "MISTRZOWSKA PI??KA",
  "CANAL+ (6)",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/07/2018 - 02/09/2018",
  "CANAL+4K ULTRA HD",
  "CANAL+4K ULTRA HD",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/09/2018 - 02/10/2018",
  "Odsetki za okres 03/09/2018 - 02/10/2018",
  "Odsetki za okres 03/08/2018 - 02/10/2018",
  "Odsetki za okres 03/08/2018 - 02/10/2018",
  "Odsetki za okres 03/07/2018 - 02/10/2018",
  "Odsetki za okres 03/07/2018 - 02/10/2018",
  "Odsetki za okres 03/06/2018 - 02/10/2018",
  "Odsetki za okres 03/11/2017 - 02/10/2018",
  "nFilmHD + nSeriale",
  "Odsetki za okres 03/10/2018 - 02/11/2018",
  "Odsetki za okres 03/10/2018 - 02/11/2018",
  "Odsetki za okres 03/09/2018 - 02/11/2018",
  "Nowy Comfort+",
  "Odsetki za okres 03/08/2018 - 02/11/2018",
  "Nowy Comfort+ z CANAL+ (6)LIVE",
  "Nowy Comfort+ z CANAL+",
  "Odsetki za okres 03/09/2018 - 02/11/2018",
  "Nowy Comfort+ z HBO",
  "Nowy Start+",
  "Dopenienie do Nowy Comfort+",
  "Dopenienie do Nowy Start+",
  "Dopenienie do Nowy Comfort+",
  "Odsetki za okres 03/08/2018 - 02/11/2018",
  "Odsetki za okres 03/05/2018 - 02/11/2018",
  "Nowy Start+ z CANAL+",
  "CANAL+ (2) LIVE",
  "Nowy Start+ z HBO",
  "Odsetki za okres 03/07/2018 - 02/11/2018",
  "Odsetki za okres 03/03/2018 - 02/11/2018",
  "Odsetki za okres 03/05/2018 - 02/11/2018",
  "Odsetki za okres 03/03/2018 - 02/11/2018",
  "Odsetki za okres 03/04/2018 - 02/11/2018",
  "Naprawa Instalacji Sat.",
  "Odsetki za okres 03/07/2018 - 02/11/2018",
  "Nowy Start+ z CANAL+ (6) LIVE",
  "Odsetki za okres 03/02/2018 - 02/11/2018",
  "Odsetki za okres 03/06/2018 - 02/11/2018",
  "Odsetki za okres 03/06/2018 - 02/11/2018",
  "Odsetki za okres 03/01/2018 - 02/11/2018",
  "Odsetki za okres 03/11/2018 - 02/12/2018"
 };

 private static String service_packages_hash_05e19c4b[]={
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Pakiety",
  "",
  "",
  "Pakiety",
  "Pakiety",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Inne",
  "Opcje premium",
  "",
  "",
  "",
  "Opcje premium",
  "",
  "",
  "Opcje premium",
  "Opcje premium",
  "Opcje premium",
  "",
  "Opcje dodatkowe",
  "",
  "Inne",
  "Opcje VOD",
  "",
  "Opcje premium",
  "",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pozostae usugi",
  "Opcje premium",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje premium",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje VOD",
  "",
  "",
  "",
  "Opcje VOD",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Oferta VOD",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje VOD",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "",
  "Inne",
  "",
  "Inne",
  "",
  "Opcje dodatkowe",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "",
  "",
  "Inne",
  "Inne",
  "Inne",
  "Opcje dodatkowe",
  "Inne",
  "",
  "",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Pakiety",
  "",
  "Pakiety",
  "Inne",
  "Inne",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "Pakiety",
  "Inne",
  "Inne",
  "",
  "",
  ""
 };

 private static String services_hash_05d02c75[]={
  "Filmbox",
  "Cinemax",
  "Filmbox",
  "Cinemax",
  "HBO + nFilmHD",
  "nPremium + HBO",
  "History HD",
  "History HD",
  "Kanay tematyczne nc+",
  "NOC",
  "RedLight HD",
  "RedLight HD",
  "NOC",
  "Multi+",
  "SunDance HD",
  "SunDance HD",
  "Multi+",
  "Universe+",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "CANAL+ Gold + HBO",
  "All Inclusive+",
  "Premium Film",
  "Comfort+",
  "Extra+",
  "CANAL+ Silver",
  "Extra+",
  "CANAL+ Gold",
  "CANAL+ Platinum",
  "CANAL+ Platinum + HBO",
  "Czynsz najmu sprztu",
  "HBO",
  "Premium Sport & Film",
  "VOD+",
  "Premium Family & Sport",
  "CANAL+ PLATINUM (opcja)",
  "HBO",
  "Inne opaty",
  "Premium Sport & Film",
  "Premium Sport",
  "Premium Film",
  "Premium Sport",
  "Mezzo",
  "Mezzo",
  "Inne opaty",
  "VOD+",
  "nc+ GO",
  "Premium Family & Sport",
  "TV France",
  "Comfort+ Extra",
  "PAPIEROWA FORMA ROZLICZENIA",
  "Universe+ Extra",
  "nc+ GO",
  "HBO GO",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "TV France",
  "Pozostae usugi",
  "CANAL+ SILVER (opcja)",
  "Sportklub",
  "Full extra",
  "Motowizja",
  "Adventure TV HD",
  "CANAL+ Film&Premiere pack",
  "Adventure TV HD",
  "Hustler HD",
  "Hustler HD",
  "Start+ Extra",
  "CANAL+ Film pack",
  "Start+ Mini",
  "Eurosport 2 HD",
  "Zest TV",
  "Motowizja",
  "Eurosport 2 HD",
  "Konto podstawowe",
  "nc+go TV",
  "History HD / H2",
  "H2",
  "nc+go TV",
  "H2",
  "Zest/Motowizja/Sportklub",
  "History HD / H2",
  "Premiery VOD+",
  "Pakiet Informacja i Rozrywka",
  "Pakiet Dzieci",
  "Pakiet Hity Filmowe",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Sport i Motoryzacja",
  "Pakiet Style Moda i Muzyka",
  "HBO + nFilmHD",
  "Pakiet Dzieci",
  "Nowy Start HD",
  "Max Pack",
  "Pakiet Hity Filmowe",
  "Max Pack",
  "nPremium + nSeriale",
  "Mix VOD",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Start HD",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO",
  "Pakiet Sport i Motoryzacja",
  "Mix VOD",
  "HBO + nFilmHD + nSeriale",
  "nPremium + nSeriale",
  "Kanay tematyczne nc+",
  "HBO + nFilmHD + nSeriale",
  "Pakiet VIP+",
  "Man Pack",
  "Pakiet Comfort+",
  "Pakiet Extra+ z CANAL+",
  "Pakiet Extra+",
  "Pakiet Superpremium+",
  "Dopenienie do Extra+",
  "Man Pack",
  "Dopenienie do Extra+",
  "Pakiet Extra+ z CANAL+ (6)",
  "Sportklub",
  "Pakiet Comfort+ z CANAL+",
  "Pakiet Extra+ z HBO",
  "Pakiet Comfort+ z CANAL+ (6)",
  "Pakiet Start+ z CANAL+ (6)",
  "Pakiet Start+",
  "Pakiet VIP+ Max",
  "Pakiet Superpremium+ (6)",
  "CANAL+",
  "Action",
  "Pakiet Entry+",
  "Pakiet Entry+ z CANAL+",
  "Zest/Motowizja/Sportklub",
  "Dopenienie do Comfort+",
  "Dopenienie do Comfort+",
  "Pakiet Start+ z CANAL+",
  "Pakiet Comfort+ z HBO",
  "Pakiet Start+ z HBO",
  "Pakiet Entry+ z CANAL+ (6)",
  "Action",
  "Zest TV",
  "Pakiet Comfort+ Bonus",
  "CANAL+ (6)",
  "Pakiet Entry+ z HBO",
  "Eleven Sports",
  "Eleven Sports",
  "Pakiet Comfort+ Bis",
  "Pakiet Extra+ Bonus",
  "Filmbox Pack",
  "Filmbox Pack",
  "Filmbox Arthouse",
  "Filmbox Arthouse",
  "Fightbox HD",
  "Fightbox HD",
  "Pakiet Superpremium(6)LIVE",
  "Pakiet Extra+CANAL+(6)LIVE",
  "Pakiet ComfortCANAL+(6)LIVE",
  "Pakiet Start+CANAL+(6)LIVE",
  "Opata za nc+ GO",
  "CANAL+ (2) LIVE",
  "CANAL+ (2)",
  "Opata za nc+ GO",
  "Dopenienie do Start+",
  "Multi Man Pack",
  "Czynsz najmu sprztu",
  "Hustler HD 2",
  "Hustler HD 2",
  "Multiroom Premium-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Opata manipulacyjna MRS",
  "Opata manipulacyjna MRS",
  "Multiroom Premium-Op.mani.",
  "Zest TV 2",
  "Dorcel TV",
  "Dorcel TV",
  "Zest TV 2",
  "Music+ Standard",
  "Music+ Premium",
  "Music+ Premium",
  "Music+ Standard",
  "Pakiet Entry+ Gotwka z Gry",
  "Odsetki za okres 03/05/2018 - 02/06/2018",
  "Odsetki za okres 03/05/2018 - 02/06/2018",
  "Odsetki za okres 03/04/2018 - 02/06/2018",
  "Odsetki za okres 03/03/2018 - 02/06/2018",
  "Odsetki za okres 03/07/2017 - 02/06/2018",
  "Odsetki za okres 03/06/2018 - 02/07/2018",
  "Odsetki za okres 03/06/2018 - 02/07/2018",
  "Odsetki za okres 03/05/2018 - 02/07/2018",
  "Odsetki za okres 03/05/2018 - 02/07/2018",
  "Odsetki za okres 03/03/2018 - 02/07/2018",
  "Odsetki za okres 03/04/2018 - 02/07/2018",
  "Odsetki za okres 03/02/2018 - 02/07/2018",
  "Odsetki za okres 03/04/2018 - 02/07/2018",
  "Odsetki za okres 03/01/2018 - 02/07/2018",
  "Multi Man Pack",
  "Odsetki za okres 03/07/2018 - 02/08/2018",
  "Odsetki za okres 03/07/2018 - 02/08/2018",
  "MISTRZOWSKA PI??KA",
  "MISTRZOWSKA PI??KA",
  "Odsetki za okres 03/06/2018 - 02/08/2018",
  "CANAL+ (6)",
  "Odsetki za okres 03/05/2018 - 02/08/2018",
  "Odsetki za okres 03/05/2018 - 02/08/2018",
  "Odsetki za okres 03/04/2018 - 02/08/2018",
  "Pakiet Superpremium+",
  "Dopenienie do Start+",
  "Odsetki za okres 03/05/2017 - 02/08/2018",
  "Pakiet Start+",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/07/2018 - 02/09/2018",
  "Odsetki za okres 03/04/2018 - 02/09/2018",
  "Odsetki za okres 03/07/2018 - 02/09/2018",
  "CANAL+4K ULTRA HD",
  "CANAL+4K ULTRA HD",
  "Odsetki za okres 03/05/2018 - 02/09/2018",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/04/2018 - 02/09/2018",
  "Odsetki za okres 03/05/2018 - 02/09/2018",
  "Odsetki za okres 03/04/2017 - 02/09/2018",
  "Odsetki za okres 03/02/2018 - 02/09/2018",
  "nFilmHD + nSeriale",
  "Odsetki za okres 02/12/2017 - 02/09/2018",
  "Odsetki za okres 03/05/2017 - 02/09/2018",
  "Odsetki za okres 03/07/2017 - 02/09/2018",
  "CANAL+ (2) LIVE",
  "Odsetki za okres 03/09/2017 - 02/09/2018",
  "Odsetki za okres 03/10/2017 - 02/09/2018",
  "Odsetki za okres 03/03/2018 - 02/09/2018"
 };

 private static String service_packages_hash_05d02c75[]={
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Pakiety",
  "",
  "",
  "Pakiety",
  "Pakiety",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Inne",
  "Opcje premium",
  "",
  "",
  "",
  "Opcje premium",
  "",
  "",
  "Opcje premium",
  "Opcje premium",
  "Opcje premium",
  "",
  "Opcje dodatkowe",
  "",
  "Inne",
  "Opcje VOD",
  "",
  "Opcje premium",
  "",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pozostae usugi",
  "Opcje premium",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje premium",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje VOD",
  "",
  "",
  "",
  "Opcje VOD",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Oferta VOD",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje VOD",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "",
  "",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Inne",
  "Inne",
  "Inne",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "Inne",
  "Inne",
  "Inne",
  "",
  "",
  "Inne",
  "",
  "Opcje dodatkowe",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "",
  "Opcje dodatkowe",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "Inne",
  "Inne",
  "",
  "",
  "",
  "Inne",
  "Inne",
  "",
  "Inne",
  "Inne",
  "Inne",
  "",
  "Inne",
  "",
  "Inne"
 };

 private static String services_hash_05d8fe25[]={
  "Filmbox",
  "Cinemax",
  "Filmbox",
  "Cinemax",
  "HBO + nFilmHD",
  "nPremium + HBO",
  "History HD",
  "History HD",
  "Kanay tematyczne nc+",
  "NOC",
  "RedLight HD",
  "RedLight HD",
  "NOC",
  "Multi+",
  "SunDance HD",
  "SunDance HD",
  "Multi+",
  "Universe+",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "CANAL+ Gold + HBO",
  "All Inclusive+",
  "Premium Film",
  "Comfort+",
  "Extra+",
  "CANAL+ Silver",
  "Extra+",
  "CANAL+ Gold",
  "CANAL+ Platinum",
  "CANAL+ Platinum + HBO",
  "Czynsz najmu sprztu",
  "HBO",
  "Premium Sport & Film",
  "VOD+",
  "Premium Family & Sport",
  "CANAL+ PLATINUM (opcja)",
  "HBO",
  "Inne opaty",
  "Premium Sport & Film",
  "Premium Sport",
  "Premium Film",
  "Premium Sport",
  "Mezzo",
  "Mezzo",
  "Inne opaty",
  "VOD+",
  "nc+ GO",
  "Premium Family & Sport",
  "TV France",
  "Comfort+ Extra",
  "PAPIEROWA FORMA ROZLICZENIA",
  "Universe+ Extra",
  "nc+ GO",
  "HBO GO",
  "Kanay CANAL+ Film&Premiere",
  "Kanay CANAL+ Premiere",
  "TV France",
  "Pozostae usugi",
  "CANAL+ SILVER (opcja)",
  "Sportklub",
  "Full extra",
  "Motowizja",
  "Adventure TV HD",
  "CANAL+ Film&Premiere pack",
  "Adventure TV HD",
  "Hustler HD",
  "Hustler HD",
  "Start+ Extra",
  "CANAL+ Film pack",
  "Start+ Mini",
  "Eurosport 2 HD",
  "Zest TV",
  "Motowizja",
  "Eurosport 2 HD",
  "Konto podstawowe",
  "nc+go TV",
  "History HD / H2",
  "H2",
  "nc+go TV",
  "H2",
  "Zest/Motowizja/Sportklub",
  "History HD / H2",
  "Premiery VOD+",
  "Pakiet Informacja i Rozrywka",
  "Pakiet Dzieci",
  "Pakiet Hity Filmowe",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Sport i Motoryzacja",
  "Pakiet Style Moda i Muzyka",
  "HBO + nFilmHD",
  "Pakiet Dzieci",
  "Nowy Start HD",
  "Max Pack",
  "Pakiet Hity Filmowe",
  "Max Pack",
  "nPremium + nSeriale",
  "Mix VOD",
  "Pakiet Kultura Nauka wiat",
  "Pakiet Start HD",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO + nSeriale",
  "nPremium + HBO",
  "Pakiet Sport i Motoryzacja",
  "Mix VOD",
  "HBO + nFilmHD + nSeriale",
  "nPremium + nSeriale",
  "Kanay tematyczne nc+",
  "HBO + nFilmHD + nSeriale",
  "Pakiet VIP+",
  "Man Pack",
  "Pakiet Comfort+",
  "Pakiet Extra+ z CANAL+",
  "Pakiet Extra+",
  "Pakiet Superpremium+",
  "Dopenienie do Extra+",
  "Man Pack",
  "Dopenienie do Extra+",
  "Pakiet Extra+ z CANAL+ (6)",
  "Sportklub",
  "Pakiet Comfort+ z CANAL+",
  "Pakiet Extra+ z HBO",
  "Pakiet Comfort+ z CANAL+ (6)",
  "Pakiet Start+ z CANAL+ (6)",
  "Pakiet Start+",
  "Pakiet VIP+ Max",
  "Pakiet Superpremium+ (6)",
  "CANAL+",
  "Action",
  "Pakiet Entry+",
  "Pakiet Entry+ z CANAL+",
  "Zest/Motowizja/Sportklub",
  "Dopenienie do Comfort+",
  "Dopenienie do Comfort+",
  "Pakiet Start+ z CANAL+",
  "Pakiet Comfort+ z HBO",
  "Pakiet Start+ z HBO",
  "Pakiet Entry+ z CANAL+ (6)",
  "Action",
  "Zest TV",
  "Pakiet Comfort+ Bonus",
  "CANAL+ (6)",
  "Pakiet Entry+ z HBO",
  "Eleven Sports",
  "Eleven Sports",
  "Pakiet Comfort+ Bis",
  "Pakiet Extra+ Bonus",
  "Filmbox Pack",
  "Filmbox Pack",
  "Filmbox Arthouse",
  "Filmbox Arthouse",
  "Fightbox HD",
  "Fightbox HD",
  "Pakiet Superpremium(6)LIVE",
  "Pakiet Extra+CANAL+(6)LIVE",
  "Pakiet ComfortCANAL+(6)LIVE",
  "Pakiet Start+CANAL+(6)LIVE",
  "Opata za nc+ GO",
  "CANAL+ (2) LIVE",
  "CANAL+ (2)",
  "Opata za nc+ GO",
  "Dopenienie do Start+",
  "Multi Man Pack",
  "Czynsz najmu sprztu",
  "Hustler HD 2",
  "Hustler HD 2",
  "Multiroom Premium-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Multiroom Standard-Op.mani.",
  "Opata manipulacyjna MRS",
  "Opata manipulacyjna MRS",
  "Multiroom Premium-Op.mani.",
  "Zest TV 2",
  "Dorcel TV",
  "Dorcel TV",
  "Zest TV 2",
  "Music+ Standard",
  "Music+ Premium",
  "Music+ Premium",
  "Music+ Standard",
  "Pakiet Entry+ Gotwka z Gry",
  "Odsetki za okres 03/06/2018 - 02/07/2018",
  "Odsetki za okres 03/06/2018 - 02/07/2018",
  "Odsetki za okres 03/05/2018 - 02/07/2018",
  "Odsetki za okres 03/05/2018 - 02/07/2018",
  "Odsetki za okres 03/03/2018 - 02/07/2018",
  "Odsetki za okres 03/02/2018 - 02/07/2018",
  "Odsetki za okres 03/04/2018 - 02/07/2018",
  "Odsetki za okres 03/01/2018 - 02/07/2018",
  "Multi Man Pack",
  "Odsetki za okres 03/07/2018 - 02/08/2018",
  "Odsetki za okres 03/07/2018 - 02/08/2018",
  "MISTRZOWSKA PI??KA",
  "MISTRZOWSKA PI??KA",
  "Odsetki za okres 03/06/2018 - 02/08/2018",
  "CANAL+ (6)",
  "Odsetki za okres 03/05/2018 - 02/08/2018",
  "Odsetki za okres 03/05/2018 - 02/08/2018",
  "Odsetki za okres 03/04/2018 - 02/08/2018",
  "Dopenienie do Start+",
  "Odsetki za okres 03/05/2017 - 02/08/2018",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/08/2018 - 02/09/2018",
  "Odsetki za okres 03/07/2018 - 02/09/2018",
  "Odsetki za okres 03/07/2018 - 02/09/2018",
  "CANAL+4K ULTRA HD",
  "CANAL+4K ULTRA HD",
  "Odsetki za okres 03/05/2018 - 02/09/2018",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/06/2018 - 02/09/2018",
  "Odsetki za okres 03/09/2018 - 02/10/2018",
  "Odsetki za okres 03/09/2018 - 02/10/2018",
  "Odsetki za okres 03/08/2018 - 02/10/2018",
  "Odsetki za okres 03/05/2018 - 02/10/2018",
  "Odsetki za okres 03/08/2018 - 02/10/2018",
  "Odsetki za okres 03/07/2018 - 02/10/2018",
  "Odsetki za okres 03/06/2018 - 02/10/2018",
  "Odsetki za okres 03/07/2018 - 02/10/2018",
  "Odsetki za okres 03/06/2018 - 02/10/2018",
  "Odsetki za okres 03/03/2018 - 02/10/2018",
  "Odsetki za okres 03/05/2018 - 02/10/2018",
  "Odsetki za okres 03/03/2018 - 02/10/2018",
  "Pakiet Extra+ z CANAL+ Bonus",
  "Odsetki za okres 03/11/2017 - 02/10/2018",
  "nFilmHD + nSeriale",
  "Odsetki za okres 03/04/2018 - 02/10/2018",
  "Odsetki za okres 03/02/2018 - 02/10/2018",
  "Odsetki za okres 03/04/2018 - 02/10/2018",
  "Odsetki za okres 03/07/2017 - 02/10/2018",
  "Odsetki za okres 03/08/2017 - 02/10/2018",
  "Pakiet VIP+",
  "Zestaw START HD",
  "HBO HD",
  "Odsetki za okres 03/02/2018 - 02/10/2018"
 };

 private static String service_packages_hash_05d8fe25[]={
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "Pakiety",
  "",
  "",
  "Pakiety",
  "Pakiety",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Inne",
  "Opcje premium",
  "",
  "",
  "",
  "Opcje premium",
  "",
  "",
  "Opcje premium",
  "Opcje premium",
  "Opcje premium",
  "",
  "Opcje dodatkowe",
  "",
  "Inne",
  "Opcje VOD",
  "",
  "Opcje premium",
  "",
  "Pakiety",
  "Inne",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pozostae usugi",
  "Opcje premium",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje premium",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje VOD",
  "",
  "",
  "",
  "Opcje VOD",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Oferta VOD",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Opcje VOD",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "Pakiety",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje premium",
  "Opcje dodatkowe",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "",
  "Opcje dodatkowe",
  "Pakiety",
  "Opcje premium",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Pakiety",
  "Opcje dodatkowe",
  "Opcje premium",
  "Opcje premium",
  "",
  "",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "Opcje dodatkowe",
  "",
  "Opcje dodatkowe",
  "",
  "Pakiety",
  "",
  "Inne",
  "",
  "Inne",
  "Inne",
  "Inne",
  "Inne",
  "Inne",
  "",
  "",
  "Inne",
  "",
  "Opcje dodatkowe",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "Opcje dodatkowe",
  "Inne",
  "Inne",
  "",
  "Inne",
  "",
  "",
  "Opcje dodatkowe",
  "Inne",
  "Inne",
  "",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "",
  "",
  "Inne",
  "Inne",
  "Inne",
  "",
  "",
  "Pakiety",
  "Inne",
  "Opcje dodatkowe",
  "Inne",
  "Inne",
  "",
  "Inne",
  "Inne",
  "",
  "Pakiety",
  "Opcje premium",
  ""
 };

 private static String decode_name(String hash_array[],String scode) {
  String name="undefined";

  try {
   int code=Integer.parseInt(scode);

   name=hash_array[code];;
  } catch(Throwable t) {}
   
  return name;
 }

 private static String[] split(String str,char c) {
  int cnt=0;

  for(int i=0;i<str.length();i++) {
   if (str.charAt(i)==c) cnt++;   
  }

  String res[]=new String[cnt+1];

  int idx=0;
  int lastpos=0;
  boolean first=true;

  for(int i=0;i<str.length();i++) {
   if (str.charAt(i)==c) {
    if (first) {
     res[idx++]=str.substring(lastpos,i);
     first=false;
    } else {
     res[idx++]=str.substring(lastpos,i);
    }

    lastpos=i+1;
   }
  }

  res[idx++]=str.substring(lastpos,str.length());

  return res;
 }

 private static Vector get_service_packages(String magic_string) {
  Vector packages=new Vector();

  String split_array_lev1[]=null;
  String split_array_lev2[]=null;
  String split_array_lev3[]=null;
  String split_array_lev4[]=null;

  try {
   split_array_lev1=split(magic_string,'^');

   for(int i=0;i<split_array_lev1.length;i++) {
    split_array_lev2=split(split_array_lev1[i],'$');
    split_array_lev3=split(split_array_lev2[1],'#');

    Vector services_for_package=new Vector();
				
    for(int j=0;j<split_array_lev3.length;j++) {
     split_array_lev4=split(split_array_lev3[j],'%');

     if (split_array_lev4.length==3) {
      services_for_package.addElement(new Service(split_array_lev4[0],split_array_lev4[1],split_array_lev4[2]));
     } else{
      services_for_package.addElement(new Service(split_array_lev4[0],split_array_lev4[1],split_array_lev4[2],split_array_lev4[3]));
     }
    } 

    packages.addElement(new ServicePackage(split_array_lev2[0],services_for_package));
   }
  } catch(Throwable t) {}

  return packages;
 }


 private static String dopad(int num) {
  String str="";

  for(int i=0;i<num;i++) {
   str+=" ";
  }

  return str;
 }

 public static String[] get_service_packages_hash(String templateid) {
  if (templateid.equals("5d88005")) {
   return service_packages_hash_05d88005;
  } else
  
  if (templateid.equals("5e1959b")) {
   return service_packages_hash_05e1959b;
  } else

  if (templateid.equals("5e19c4b")) {
   return service_packages_hash_05e19c4b;
  } else

  if (templateid.equals("5d02c75")) {
   return service_packages_hash_05d02c75;
  } else

  if (templateid.equals("5d8fe25")) {
   return service_packages_hash_05d8fe25;
  } else return new String[0];

 }

 public static String[] get_services_hash(String templateid) {
  if (templateid.equals("5d88005")) {
   return services_hash_05d88005;
  } else

  if (templateid.equals("5e1959b")) {
   return services_hash_05e1959b;
  } else

  if (templateid.equals("5e19c4b")) {
   return services_hash_05e19c4b;
  } else

  if (templateid.equals("5d02c75")) {
   return services_hash_05d02c75;
  } else

  if (templateid.equals("5d8fe25")) {
   return services_hash_05d8fe25;
  } else return new String[0];
 }

 public static void print_invoice(String invoice,String addr,String templateid,int print_type) throws Throwable {
  try {
   String args[]=split(invoice,'|');

   String s=Utils.padded_string(args[INVOICE_NUMBER],PAD2)+" | "+args[START_DATE]+" | "+args[END_DATE];
   s+=" | "+Utils.padded_string(args[AGREEMENT_NUMBER],PAD3)+" | "+Utils.padded_string(addr,PAD3);
   s+=" | "+Utils.padded_string(args[PAYMENT_AMOUNT],PAD2);

   Output.text(s);

   if (print_type==1) {
    String service_packages_hash[]=get_service_packages_hash(templateid);
    String services_hash[]=get_services_hash(templateid);

    print_packages(1,args[MAGIC_STRING],service_packages_hash,services_hash);
    separator_line();
   }
  } catch(Throwable t) {
  }

 }

 private static void separator_line() throws Throwable {
  String s="----------------------------------------------------------------------------------";
  Output.text(s);
 }

 public static void print_header() throws Throwable {
  separator_line();

  String s="INVOICE NUMBER     | FROM       | TO         | AGREEMENT #  | CARD NUMBER  | PLN";
  Output.text(s);

  separator_line();
 }

 private static String get_cardaddr(String data) {
  String cardaddr="";

  int idx=data.indexOf("s=\"");
 
  if (idx>0) {
   int idx2=data.indexOf('\"',idx+3);

   if (idx2>0) {
    cardaddr=data.substring(idx+3,idx2);
   }
  }

  return cardaddr;
 }

 private static String get_template_id(String data) {
  String template_id="";

  int idx=data.indexOf("t=\"");
 
  if (idx>0) {
   int idx2=data.indexOf('\"',idx+3);

   if (idx2>0) {
    template_id=data.substring(idx+3,idx2);
   }
  }

  return template_id;
 }

 public static int print_invoices(String invoicedata,int print_type,int maxcnt) throws Throwable {
  int pos=0;
  int cnt=0;

  boolean first=true;

  if (invoicedata.startsWith("<MP")) return 0;

  while(pos<invoicedata.length()) {
   if (cnt>=maxcnt) break;

   char c=invoicedata.charAt(pos);

   if (c=='<') {
    int idx=invoicedata.indexOf('>',pos);

    if (idx>0) {
     String addr=get_cardaddr(invoicedata.substring(pos+3,idx));
     String templateid=get_template_id(invoicedata.substring(pos+3,idx));

     int idx2=invoicedata.indexOf('<',idx);

     String data=invoicedata.substring(idx+1,idx2);

     idx=invoicedata.indexOf('>',idx2);
     pos=idx+1;

     if (first) {
      print_header();
      first=false;
     }

     print_invoice(data,addr,templateid,print_type);

     cnt++;
    }
   } else break;
  }

  return cnt;
 }

 public static void print_packages(int pad,String magic_string,String service_packages_hash[],String services_hash[]) throws Throwable {
  Vector packages=get_service_packages(magic_string);

  for(int i=0;i<packages.size();i++) {
   ServicePackage spkg=(ServicePackage)packages.elementAt(i);

   String s=dopad(pad)+decode_name(service_packages_hash,spkg.name);

   Output.text(s);

   Vector services=spkg.services;
   
   for(int j=0;j<services.size();j++) {
    Service srv=(Service)services.elementAt(j);

    s=dopad(pad+2)+"- "+Utils.padded_string(decode_name(services_hash,srv.name),PAD)+" "+srv.price;
    Output.text(s);
   }
  }
 }

 public static void main(String args[]) {
  try {
   ByteArrayOutputStream baos=new ByteArrayOutputStream();
   FileInputStream f=new FileInputStream(args[0]);

   while(true) {
    int val=f.read();
    if (val<0) break;

    baos.write(val);
   }
 
   byte data[]=baos.toByteArray();

   print_invoices(new String(data),0,30);
  } catch(Throwable t) {}
 }
}
